catalog/models.py
from app import db  # from the app package __init__
from datetime import datetime


# PUBLICATION TABLE
class Publication(db.Model):
    __tablename__ = 'publication'

    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(80), nullable=False)

    def __init__(self, name):
        self.name = name

    def __repr__(self):
        return 'The Publisher is {}'.format(self.name)


# BOOKS TABLE
class Book(db.Model):
    __tablename__ = 'book'

    id = db.Column(db.Integer, primary_key=True)
    title = db.Column(db.String(500), nullable=False, index=True)
    author = db.Column(db.String(350))
    avg_rating = db.Column(db.Float)
    format = db.Column(db.String(50))
    image = db.Column(db.String(100), unique=True)
    num_pages = db.Column(db.Integer)
    pub_date = db.Column(db.DateTime, default=datetime.utcnow())

    # ESTABLISH RELATIONSHIP
    pub_id = db.Column(db.Integer, db.ForeignKey('publication.id'))

    def __init__(self, title, author, avg_rating, book_format, image, num_pages, pub_id):
        self.title = title
        self.author = author
        self.avg_rating = avg_rating
        self.format = book_format
        self.image = image
        self.num_pages = num_pages
        self.pub_id = pub_id

    def __repr__(self):
        return '{} by {}'.format(self.title, self.author)

catalog/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField, IntegerField, FloatField
from wtforms.validators import DataRequired


class EditBookForm(FlaskForm):
    title = StringField('Title', validators=[DataRequired()])
    format = StringField('Format', validators=[DataRequired()])
    num_pages = StringField('Pages', validators=[DataRequired()])
    submit = SubmitField('Update')


class CreateBookForm(FlaskForm):
    title = StringField('Title', validators=[DataRequired()])
    author = StringField('Author', validators=[DataRequired()])
    avg_rating = FloatField('Rating', validators=[DataRequired()])
    format = StringField('Format', validators=[DataRequired()])
    img_url = StringField('Image', validators=[DataRequired()])
    num_pages = IntegerField('Pages', validators=[DataRequired()])
    pub_id = IntegerField('PublisherID', validators=[DataRequired()])
    submit = SubmitField('Create')

catalog/__init__.py
from flask import Blueprint

main = Blueprint('main', __name__, template_folder='templates')
from app.catalog import routes, models  # to avoid circular imports

catalog/routes.py
# catalog/routes.py

from app.catalog import main
from app import db
from app.catalog.models import Book, Publication
from app.catalog.forms import EditBookForm, CreateBookForm
from flask import render_template, request, redirect, url_for, flash
from flask_login import login_required


@main.route('/')
def display_books():
    books = Book.query.all()
    return render_template('home.html', books=books)


@main.route('/display/publisher/<publisher_id>')
def display_publisher(publisher_id):
    publisher = Publication.query.filter_by(id=publisher_id).first()
    publisher_books = Book.query.filter_by(pub_id=publisher.id).all()
    return render_template('publisher.html', publisher=publisher, publisher_books=publisher_books)


@main.route('/book/delete/<book_id>', methods=['GET', 'POST'])
@login_required
def delete_book(book_id):
    book = Book.query.get(book_id)
    if request.method == 'POST':
        db.session.delete(book)
        db.session.commit()
        flash('Book deleted successfully')
        return redirect(url_for('main.display_books'))
    return render_template('delete_book.html', book=book, book_id=book.id)


@main.route('/edit/book/<book_id>', methods=['GET', 'POST'])
@login_required
def edit_book(book_id):
    book = Book.query.get_or_404(book_id)
    form = EditBookForm(obj=book)
    if form.validate_on_submit():
        book.title = form.title.data
        book.format = form.format.data
        book.num_pages = form.num_pages.data
        db.session.add(book)
        db.session.commit()
        flash('Book Edited Successfully')
        return redirect(url_for('main.display_books'))
    return render_template('edit_book.html', form=form)


@main.route('/create/book/<pub_id>', methods=['GET', 'POST'])
@login_required
def create_book(pub_id):
    form = CreateBookForm()
    form.pub_id.data = pub_id  # pre-populates pub_id
    if form.validate_on_submit():
        # book = Book()
        # form.populate_obj(book)
        book = Book(title=form.title.data, author=form.author.data, avg_rating=form.avg_rating.data,
                    book_format=form.format.data, image=form.img_url.data, num_pages=form.num_pages.data,
                    pub_id=form.pub_id.data)
        db.session.add(book)
        db.session.commit()
        flash('Book added successfully')
        return redirect(url_for('main.display_publisher', publisher_id=pub_id))
    return render_template('create_book.html', form=form, pub_id=pub_id)

catalog/templates/create_book.html
{% extends 'layout.html' %}

{% block content %}
    <div class="container">
        <h4 style="margin-left: 45px"> create a new book </h4>
        <hr>
          {{ form.hidden_tag() }}
          {{ wtf.quick_form(form) }}
    </div>
{% endblock %}

catalog/templates/delete_book.html
<!--catalog/templates/delete_book.html-->

{% extends 'layout.html' %}

{% block content %}
    <div class="container">
        <h4 style="margin-left: 45px"> delete the book ? </h4>
        <hr>
            <p style="margin-left: 45px">
                Book Id: {{ book.id }}<br>
                Title: {{ book.title }}<br>
                Author: {{ book.author }}
            </p>
        <br>
        <form action="" method="POST" style="margin-left: 45px">
            <button type="submit" class="btn btn-sm btn-primary"> delete </button>
        </form>
    </div>
{% endblock %}

catalog/templates/edit_book.html
{% extends 'layout.html' %}

{% block content %}
    <div class="container">
        <h4 style="margin-left: 45px"> update this book </h4>
        <hr>
          {{ form.hidden_tag() }}
          {{ wtf.quick_form(form) }}
    </div>
{% endblock %}

catalog/templates/home.html
<!--catalog/templates/home.html-->
{% extends 'layout.html' %}


{% block content %}
    <div class="container books">
        <div class="row">
        {% for book in books %}
            <div class="col-md-4">
                <img src="static/img/{{ book.image }}" alt="book-img" height="200" width="190" class="img-rounded">
                <h4> Title: {{ book.title }} </h4>
                <p> Authors: {{ book.author }} </p>
                <p> Format: {{ book.format }} </p>
                <p> Average Rating: {{ book.avg_rating }} </p>
                <p> Pages: {{ book.num_pages }} </p>
                <p><a href="{{ url_for('main.display_publisher', publisher_id=book.pub_id) }}">Publisher ID: {{ book.pub_id }}</a></p>
                <span class="label label-success"><a href="{{ url_for('main.create_book', pub_id=book.pub_id) }}" style="color: floralwhite"> create </a></span>
                <span class="label label-primary"><a href="{{ url_for('main.edit_book', book_id=book.id) }}" style="color: floralwhite"> edit </a></span>
                <span class="label label-info"><a href="{{ url_for('main.delete_book', book_id=book.id) }}" style="color: floralwhite"> delete </a></span>
                <br>
            </div>
        {% endfor %}
        </div>
    </div>
{% endblock content %}

catalog/templates/layout.html
{% import "bootstrap/wtf.html" as wtf %}

<html lang="en">

    {# head #}
    {% block head %}
        <head>
            <title> books Inc </title>
            <meta charset="UTF-8">
            <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
            <link href="https://fonts.googleapis.com/css?family=Sansita" rel="stylesheet">
            <link rel="stylesheet" href="{{ url_for('static', filename='css/styles.css') }}">
        </head>
    {% endblock head %}

    {# body #}
    {% block body %}
    <body>
    <div class="wrapper">
        {# navigation bar #}
        {% block navbar %}
        <nav class="navbar navbar-inverse">
            <div class="container">
                <a class="navbar-brand title" href="{{ url_for('main.display_books') }}">Book Shop Around the Corner</a>

                <ul class="nav navbar-nav pull-right nav-list">
                    <li><a href="{{ url_for('main.display_books') }}"> Home </a></li>
                    <li><a href="{{ url_for('authentication.register_user') }}"> Register </a></li>
                    <li>
                        {% if current_user.is_authenticated %}
                            <a href="{{ url_for('authentication.log_out_user') }}"> SignOut </a>
                        {% else %}
                            <a href="{{ url_for('authentication.do_the_login') }}"> SignIn </a>
                        {% endif %}
                    </li>
                    <li>
                        <a href="">
                            {%  if current_user.is_authenticated %}
                                LoggedIn as <b style="color: deeppink">{{ current_user.user_name.title() }}</b>
                            {% else %}
                                Not LoggedIn
                            {% endif %}
                        </a>
                    </li>
                </ul>
            </div>
        </nav>
        {% endblock navbar %}

        {# flash messaging #}
        {% for message in get_flashed_messages() %}
            <div class="container alert alert-info">
                <button type="button" class="close" data-dismiss="alert"></button>
                {{ message }}
            </div>
        {% endfor %}

        {# empty block for custom content #}
        {% block content %} {% endblock content %}

        {# footer #}
        {% block footer %}
        <footer>
            <div class="container ftr">
                <hr>
                <p class="text-center small"> The Shop Around The Corner &copy;	| 2019 </p>
            </div>
        </footer>
        {% endblock footer %}

    </div>
    </body>
    {% endblock body %}
</html>

catalog/templates/publisher.html
{% extends 'layout.html' %}

{% block content %}
    <div class="container publisher">
        <h4> Books by {{ publisher.name }} </h4>
        <hr><br>
        <ol>
            {% for book in publisher_books %}
                <li type="1">
                    {{ book.title }} by {{ book.author }}
                </li>
            {% endfor %}
        </ol>
    </div>
{% endblock content %}